#include "BinValueEditor.h"
#include <QLabel>
#include <QLayout>

#include <iostream>
using namespace std ;

BinValueEditor::BinValueEditor(unsigned int *wo,unsigned int bi ,
                               const QString& tx, QWidget *parent, bool editable ) :
        QWidget(parent),
        label(tx), word(wo), bit(bi)
{
    QHBoxLayout *Lthis = new QHBoxLayout(this) ;
    Lthis->setSpacing(0);

    QString nb ;
    QLabel *l =  new QLabel(nb.sprintf("%2d",bi), this) ;
    Lthis->addWidget(l);
    int hh = l->fontMetrics().width("DD");
    l->setMargin(0) ;
    l->setFixedWidth(hh) ;
    l->setFixedHeight(20);
    cb = new  QCheckBox(tx,this) ;
    cb ->setEnabled(editable);
    Lthis->addWidget(cb);

    connect(cb,SIGNAL(clicked()), this, SLOT(updateWord())) ;
    updateDisplay() ;
}

void  BinValueEditor::updateDisplay()
{
    // force bits if they are named 0 or 1
    if(label == "0")
        *word &= ~(1<<bit) ;
    else if( label  == "1")
        *word |= (1<<bit) ;

    cb->setChecked(*word & (1 << bit)) ;

//cout << "label = " << label << " " <<  ((*word & (1 << bit)) != 0) << endl ;
}

void  BinValueEditor::updateWord()
{
    if(cb->isChecked())
        *word |= (1 << bit)	 ;
    else
        *word &= (~(1 << bit)) ;
    emit bitChanged() ;
}
